package giuseppe.salvi.tts;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "giuseppe.salvi.tts", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "giuseppe.salvi.tts", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public com.giuseppe.salvi.icos.library.TextToSpeech.TTs _tts = null;
public static String _a = "";
public static String _b = "";
public anywheresoftware.b4a.objects.LabelWrapper _lb = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 13;BA.debugLine="tts.InitializeTTs(\"tts\",\"en\")";
mostCurrent._tts.InitializeTTs(mostCurrent.activityBA,"tts","en");
 //BA.debugLineNum = 15;BA.debugLine="Activity.LoadLayout(\"icostts\")";
mostCurrent._activity.LoadLayout("icostts",mostCurrent.activityBA);
 //BA.debugLineNum = 16;BA.debugLine="Activity.AddMenuItem(\"Esci\",\"esci\")";
mostCurrent._activity.AddMenuItem("Esci","esci");
 //BA.debugLineNum = 17;BA.debugLine="Activity.Title=\"ICOSTextToSpeech Library - Copyright Giuseppe Salvi\"";
mostCurrent._activity.setTitle((Object)("ICOSTextToSpeech Library - Copyright Giuseppe Salvi"));
 //BA.debugLineNum = 19;BA.debugLine="a=\"a 27-year-old Somali man has been charged with attempted murder, \" _ 	&\"assault AND kidnapping after an alleged armed rampage across Christchurch which ended when he was shot by police.\"";
mostCurrent._a = "a 27-year-old Somali man has been charged with attempted murder, "+"assault AND kidnapping after an alleged armed rampage across Christchurch which ended when he was shot by police.";
 //BA.debugLineNum = 22;BA.debugLine="b=\"In a special court sitting at his bedside in Christchurch Hospital today,\" _ 	&\"where the man Is under police guard As he recovers from the wounds he suffered, Judge Paul Kellar suppressed the man's name,\" _  	&\" and a request was made for him to undergo a psychiatric assessment.\"";
mostCurrent._b = "In a special court sitting at his bedside in Christchurch Hospital today,"+"where the man Is under police guard As he recovers from the wounds he suffered, Judge Paul Kellar suppressed the man's name,"+" and a request was made for him to undergo a psychiatric assessment.";
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _b1_click() throws Exception{
 //BA.debugLineNum = 43;BA.debugLine="Sub b1_Click";
 //BA.debugLineNum = 44;BA.debugLine="tts.ReadAndSpeakSMS";
mostCurrent._tts.ReadAndSpeakSMS(mostCurrent.activityBA);
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static String  _b10_click() throws Exception{
 //BA.debugLineNum = 79;BA.debugLine="Sub b10_Click";
 //BA.debugLineNum = 80;BA.debugLine="tts.StopToSpeak";
mostCurrent._tts.StopToSpeak(mostCurrent.activityBA);
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
public static String  _b11_click() throws Exception{
 //BA.debugLineNum = 83;BA.debugLine="Sub b11_Click";
 //BA.debugLineNum = 84;BA.debugLine="tts.Speaking(a)";
mostCurrent._tts.Speaking(mostCurrent.activityBA,mostCurrent._a);
 //BA.debugLineNum = 85;BA.debugLine="tts.PlaySilence(1000)";
mostCurrent._tts.PlaySilence(mostCurrent.activityBA,(long)(1000));
 //BA.debugLineNum = 86;BA.debugLine="tts.AddSpeaking(b)";
mostCurrent._tts.AddSpeaking(mostCurrent.activityBA,mostCurrent._b);
 //BA.debugLineNum = 87;BA.debugLine="tts.PlaySilence(3000)";
mostCurrent._tts.PlaySilence(mostCurrent.activityBA,(long)(3000));
 //BA.debugLineNum = 88;BA.debugLine="tts.AddSpeaking(a)";
mostCurrent._tts.AddSpeaking(mostCurrent.activityBA,mostCurrent._a);
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _b12_click() throws Exception{
 //BA.debugLineNum = 91;BA.debugLine="Sub b12_Click";
 //BA.debugLineNum = 92;BA.debugLine="tts.ChangeDefaultLanguage";
mostCurrent._tts.ChangeDefaultLanguage(mostCurrent.activityBA);
 //BA.debugLineNum = 93;BA.debugLine="End Sub";
return "";
}
public static String  _b13_click() throws Exception{
 //BA.debugLineNum = 95;BA.debugLine="Sub b13_Click";
 //BA.debugLineNum = 96;BA.debugLine="tts.GoLanguageSettings";
mostCurrent._tts.GoLanguageSettings(mostCurrent.activityBA);
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _b2_click() throws Exception{
 //BA.debugLineNum = 47;BA.debugLine="Sub b2_Click";
 //BA.debugLineNum = 48;BA.debugLine="tts.WriteAndSpeakText";
mostCurrent._tts.WriteAndSpeakText(mostCurrent.activityBA);
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _b3_click() throws Exception{
 //BA.debugLineNum = 51;BA.debugLine="Sub b3_click";
 //BA.debugLineNum = 52;BA.debugLine="tts.SetLanguageToSpeak";
mostCurrent._tts.SetLanguageToSpeak(mostCurrent.activityBA);
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _b4_click() throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub b4_Click";
 //BA.debugLineNum = 56;BA.debugLine="tts.SetEngineByPackageName(\"com.ivona.tts\")";
mostCurrent._tts.SetEngineByPackageName(mostCurrent.activityBA,"com.ivona.tts");
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _b5_click() throws Exception{
 //BA.debugLineNum = 59;BA.debugLine="Sub b5_Click";
 //BA.debugLineNum = 60;BA.debugLine="lb.Text=tts.GetEngineByPackageName";
mostCurrent._lb.setText((Object)(mostCurrent._tts.GetEngineByPackageName(mostCurrent.activityBA)));
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
return "";
}
public static String  _b6_click() throws Exception{
 //BA.debugLineNum = 63;BA.debugLine="Sub b6_Click";
 //BA.debugLineNum = 64;BA.debugLine="tts.PitchToSpeak(6.5)";
mostCurrent._tts.PitchToSpeak(mostCurrent.activityBA,(float)(6.5));
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}
public static String  _b7_click() throws Exception{
 //BA.debugLineNum = 67;BA.debugLine="Sub b7_Click";
 //BA.debugLineNum = 68;BA.debugLine="tts.RateToSpeak(0.5)";
mostCurrent._tts.RateToSpeak(mostCurrent.activityBA,(float)(0.5));
 //BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}
public static String  _b8_click() throws Exception{
 //BA.debugLineNum = 71;BA.debugLine="Sub b8_Click";
 //BA.debugLineNum = 72;BA.debugLine="tts.Speaking(a)";
mostCurrent._tts.Speaking(mostCurrent.activityBA,mostCurrent._a);
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _b9_click() throws Exception{
 //BA.debugLineNum = 75;BA.debugLine="Sub b9_Click";
 //BA.debugLineNum = 76;BA.debugLine="tts.AddSpeaking(b)";
mostCurrent._tts.AddSpeaking(mostCurrent.activityBA,mostCurrent._b);
 //BA.debugLineNum = 77;BA.debugLine="End Sub";
return "";
}
public static String  _esci_click() throws Exception{
 //BA.debugLineNum = 100;BA.debugLine="Sub esci_Click";
 //BA.debugLineNum = 101;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 102;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 5;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 6;BA.debugLine="Dim tts As ICOSTextToSpeech";
mostCurrent._tts = new com.giuseppe.salvi.icos.library.TextToSpeech.TTs();
 //BA.debugLineNum = 7;BA.debugLine="Dim a,b As String";
mostCurrent._a = "";
mostCurrent._b = "";
 //BA.debugLineNum = 8;BA.debugLine="Dim lb As Label";
mostCurrent._lb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 3;BA.debugLine="End Sub";
return "";
}
public static String  _tts_ready(boolean _success) throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub tts_Ready (Success As Boolean)";
 //BA.debugLineNum = 28;BA.debugLine="If Success   Then";
if (_success) { 
 //BA.debugLineNum = 29;BA.debugLine="ToastMessageShow(\"TTS is Ready\",True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("TTS is Ready",anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 31;BA.debugLine="ToastMessageShow(\"TTS is not Ready\",True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("TTS is not Ready",anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
}
